/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */

/*
 *  This file is part of Moka.
 *
 *  Moka is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Moka; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package moka.x;

import moka.x.CaptionedComponent;
import moka.util.StringTokenizer;
import moka.lang.System;

/**
 * TextArea class is a text entry component.
 *
 * @author  Frdric Brown
 * @version 1.0, 2003-03-10
 * @since   MDK1.0a
 */
public class TextArea extends CaptionedComponent {
	/** The number of character this TextField should accept. Should be > 0.*/
	public short maxLength;

	/** Should the words be warped ? Should be only read.*/
	public boolean warp;

	/*
	 * Constructs a new TextArea.
	 */
	public TextArea () {
		this("");
	}

	/*
	 * Constructs a new TextArea specifying its caption.
	 *
	 * @param caption the TextArea's caption.
	 */
	public TextArea (String caption) {
	}

	/**
	 * Sets if the words should be warped.
	 *
	 * @param b true to specify that the words should be warped, false to specify that the words should not be warped
	 */
	public void setWarp(boolean b) {
		this.warp = b;
	}

	/**
	 * Paints the TextArea.
	 */
	public native void paint() ;

	/**
	 * Prints the text in this TextArea while warping words.
	 *
	 * @param str The text to print
	 * @param x The x position
	 * @param y The y position
	 */
	private native void printTextWarp (char_p str, short x, short y) ;

	/**
	 * Prints the text in this TextArea without warping words.
	 *
	 * @param str The text to print
	 * @param x The x position
	 * @param y The y position
	 * @param cur The current position
	 */
	private native void printTextNoWarp (char_p str, short x, short y, short cur) ;

	/**
	 * This method is invoked by the GEM when the user interacts
	 * with the TextArea.
	 */
	public void use () {
	}
}