/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2004 Frdric Brown
 */

/*
 *  This file is part of Moka.
 *
 *  Moka is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Moka; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import moka.lang.System;//Import the class moka.lang.System
import moka.lang.DLL;//Import the class moka.lang.System

/**
 * This class is an example using DLLs. It is an adapted version of the TIGCC's "How to break the 64 KB limit using a DLL" documentation entry.
 *
 * @author  Frdric Brown
 */
public class ExDLL {
    /**
     * The main function is the entry point of a Moka program.
    */
    public static void main () {
		/* Load the DLL */
		if (DLL.load ("mydll", 372377271, 2, 11) != DLL.DLL_OK)
		{
			/* If DLL loading failed, show error message */
			System.print ("Error loading DLL!");
			System.read();//Wait for the user to press a key
			return;
		}

		System.clrscr (); //Clear the screen

		MyDLL.globalVarInDLL = 1234567;//Assing a value to a global var in DLL

		/* Execute functions from the DLL */
		MyDLL.helloFromDLL ();
		System.println ( MyDLL.sumFromDLL (2, 3));
		System.println ( MyDLL.messageInDLL );

		System.read ();//Wait for the user to press a key

		DLL.unload (); // Unload the DLL

    }
}