/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */

/*
 *  This file is part of Moka.
 *
 *  Moka is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Moka; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import moka.lang.System;//Import the class moka.lang.System
import moka.lang.Use_GarbageCollection;//Import the class moka.lang.Use_GarbageCollection

/**
 * This class demonstrate that the garbage collector works.  It instanciates many object and do not
 * finalize them.  Memory leak should not appear.  They can be checked via the MEM menu.  Copy the program
 * on the calculator and run it once.  Then clean the screen and check the available RAM in the MEM menu.
 * Run the program again and check the available RAM.
 *
 * @author  Frdric Brown
 */
public class Garbage implements Use_GarbageCollection {
    /**
     * The main function is the entry point of a Moka program.
    */
    public static void main () {
       "Hello, world!"; //Instanciate a String
       "Hello, world!"; //Instanciate a String
       "Hello, world!"; //Instanciate a String
       "Hello, world!"; //Instanciate a String
       "Hello, world!"; //Instanciate a String
       
       new Object(); //Instanciate an Object
       
       new Object[4][5];//Instanciate an Object array
       
       System.malloc(50);//Allocate 50 bytes
    }
}