/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */

/*
 *  This file is part of Moka.
 *
 *  Moka is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Moka; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import moka.io.Keyboard;//Import the class moka.io.Keyboard

/**
 * This class represents the Player 2 of the Tron game.  This class is a subclass of Player.
 *
 * @author  Frdric Brown
 */
public class Player2 extends Player {

	/**
	 * Initializes a newly allocated Player2.
	 */
	public Player2 () {
		super(2s);//Call the superclass' constructor, passing 2 as argument
	}

	/**
	 * Reads the keyboard to set the new direction
	 * of the Player.
	 *
	 * @param kb The Keyboard to read
	 */
	public void readKb (Keyboard kb) {
			if (kb.key_W && this.direct != Player.DOWN_DIRECTION) {//If UP is pressed
				this.direct = Player.UP_DIRECTION;//Set the player 2 direction to up
			}
			else if (kb.key_S && this.direct != Player.UP_DIRECTION) {//If DOWN is pressed
				this.direct = Player.DOWN_DIRECTION;//Set the player 2 direction to down
			}
			else if (kb.key_A && this.direct != Player.RIGHT_DIRECTION) {//If LEFT is pressed
				this.direct = Player.LEFT_DIRECTION;//Set the player 2 direction to left
			}
			else if (kb.key_D && this.direct != Player.LEFT_DIRECTION) {//If RIGHT is pressed
				this.direct = Player.RIGHT_DIRECTION;//Set the player 2 direction to right
			}
	}

}