/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */

/*
 *  This file is part of Moka.
 *
 *  Moka is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Moka; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import moka.lang.System;//Import the class moka.io.Keyboard
import moka.io.Keyboard;//Import the class moka.io.Keyboard
import moka.io.Socket;//Import the class moka.io.Keyboard

/**
 * This class is the main class of the client of a network Tron game. The remote player uses its arrow keys to play.
 * NB: The client program should be launched after the server one.
 *
 * @author  Frdric Brown
 */
public class Client {
    /**
     * The main function is the entry point of a Moka program.
    */
    public static void main () {
    	short direct = Player.NO_DIRECTION;//Set the initial direction of the player
    	Keyboard kb = new Keyboard();//A keyboard object used to read keys
    	Socket sok = new Socket();//Instanciate a new Socket
		
		System.clrscr();//Clear the screen
		System.print("Use the arrow keys\nto move your Tron.\nESC to quit ...");//Write "Use the arrow keys\nto move your Tron.\nESC to quit ..."

		while (! kb.key_ESC) {//While ESC is not pressed
			kb.checkKeys();//Check which keys are pressed
			if (kb.key_Up) {//If UP is pressed
				direct = Player.UP_DIRECTION;//Set the player 1 direction to up
			}
			else if (kb.key_Down) {//If DOWN is pressed
				direct = Player.DOWN_DIRECTION;//Set the player 1 direction to down
			}
			else if (kb.key_Left) {//If LEFT is pressed
				direct = Player.LEFT_DIRECTION;//Set the player 1 direction to left
			}
			else if (kb.key_Right) {//If RIGHT is pressed
				direct = Player.RIGHT_DIRECTION;//Set the player 1 direction to right
			}
			sok.open();//Open the socket
			
			sok.writeShort(direct);//Write the direct short in the socket
			
			sok.close();//Close the socket
		}

		kb.finalize();//Finalize kb
		sok.finalize();//Finalize sok
		Keyboard.flush();//Flush the keyboard queue
    }
}