/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2004 Frdric Brown
 */

/*
 *  This file is part of Moka.
 *
 *  Moka is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Moka; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import moka.io.RowRead;//Import the class moka.io.RowRead
import moka.lang.System;//Import the class moka.lang.System

/**
 * This class is an example of the use of class RowRead.
 *
 * @author  Frdric Brown
 */
public class RRTest {
    /**
     * The main function is the entry point of a Moka program.
    */
    public static void main () {
		RowRead.enable();//Prepare a row read session
		do {
			// Print some values for some keys.
			if (RowRead.key_A) {
				System.print('a');
			}
			if (RowRead.key_C) {
				System.print('c');
			}
			if (RowRead.key_Up) {
				System.print("Up:");
			}
			//If the DownRight key is pressed
			if (RowRead.key_Right && RowRead.key_Down) {
				System.print("DownRight:");
				continue;
			}
			if (RowRead.key_Down) {
				System.print("Down:");
			}
			if (RowRead.key_Left) {
				System.print("Left:");
			}
			if (RowRead.key_Right) {
				System.print("Right:");
			}
		}
		while (! RowRead.key_ESC );//Loop until the escape key is pressed

		RowRead.disable();//End a row read session
    }
}