/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */
 
/*
 *  This file is part of Moka.
 *
 *  Moka is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Moka; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import moka.lang.System;
import moka.util.StringTokenizer;

/**
 * This class shows the work of a StringTokenizer.
 *
 * @author  Frdric Brown
 */
public abstract final class Token {
	public static void main () {
		StringTokenizer st = new StringTokenizer("My name is Bob.\nI'm 5 years old.\rI'm happy!");//Instanciate a new StringTokenizer
		
		System.clrscr();//Clears the screen.
		
		while (st.hasMoreTokens()) { //While there is more tokens
			System.println(st.nextToken());//Print the next token
		}
		
		System.read();//Wait for the user to press a key
		
		st.setCurrentPosition(0);//Sets the current position to 0 (the begining of the string)
		
		System.println(st.nextToken("\r"));//Sets the delimiter to '\r' and Print the next token
		
		System.println(st.nextToken());//Print the next token with the new delimiter
		
		st.finalize();//Finalize st
		
		System.read();//Wait for the user to press a key
	}
	
}