/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */

/*
 *  This file is part of Moka.
 *
 *  Moka is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Moka; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import moka.lang.System;//Import the class moka.lang.System
import moka.io.Keyboard;//Import the class moka.io.Keyboard
import moka.io.Graphics;//Import the class moka.io.Graphics
import moka.util.Timer;//Import the class moka.util.Timer

/**
 * This class is a Tron game. Player 1 uses the arrows, player 2 uses W, A, S and D. ESC to quit.
 *
 * @author  Frdric Brown
 */
public class Tron {
    /**
     * The main function is the entry point of a Moka program.
    */
    public static void main () {
    	short p1p = 0;//A short containing the points of player 1
    	short p2p = 0;//A short containing the points of player 2
    	short p1d;//A short containing the dirrection of player 1
    	short p2d;//A short containing the dirrection of player 2
    	short p1x;//A short containing the x coordinate of player 1
    	short p2x;//A short containing the x coordinate of player 2
    	short p1y;//A short containing the y coordinate of player 1
    	short p2y;//A short containing the y coordinate of player 2
    	Keyboard kb = new Keyboard();//A keyboard object used to read keys
    	short x_max;//The maximum x coordinate
    	short y_max;//The maximum y coordinate

		if (System.CALCULATOR == System.CALCULATOR_TI89) {//If the calculator is a TI-89
			x_max = 149;//Set the maximum x coordinate to 149
			y_max = 93;//Set the maximum y coordinate to 93
		}
		else {
			x_max = 239;//Set the maximum x coordinate to 239
			y_max = 122;//Set the maximum y coordinate to 122
		}

		System.clrscr();//Clear the screen
		System.println("TRON");//Write "TRON" then next line
		System.println("Player 1 uses the arrows,\nplayer 2 uses W, A, S and\nD. ESC to quit.\n\nPlayer 1 begins in upper\nleft, player 2 begins in\nlower right.");//Write the instructions then next line
		System.println();//Next line
		System.print("Press a key ...");//Write "Press a key ..."
		System.read();//Wait for the user to press a key

		Keyboard.flush();//Flush the keyboard queue
    	while (!kb.key_ESC) {//While ESC is not pressed
    		System.clrscr();//Clear the screen
	    	System.println("TRON");//Write "TRON" then next line
	    	/*Write Player 1: (Number of points of player 1).*/
	    	System.print("Player 1: ");
	    	System.println(p1p);

	    	/*Write Player 1: (Number of points of player 2).*/
	    	System.print("Player 2: ");
	    	System.println(p2p);

	    	/*Draw the borders.*/
	    	Graphics.drawLine(0s, 30s, x_max, 30s, Graphics.NORMAL_ATTR);
	    	Graphics.drawLine(0s, 30s, 0s, y_max, Graphics.NORMAL_ATTR);
	    	Graphics.drawLine(0s, y_max, x_max, y_max, Graphics.NORMAL_ATTR);
	    	Graphics.drawLine(x_max, 30s, x_max, y_max, Graphics.NORMAL_ATTR);

			p1d = -1;//Set the player 1 direction to no direction
			p2d = -1;//Set the player 2 direction to no direction
			p1x = 5;//Set the player 1 x to 5
			p1y = 35;//Set the player 1 y to 35
			p2y = y_max - 5;//Set the player 2 y to y_max - 5
			p2x = x_max - 5;//Set the player 2 x to x_max - 5
	    	Graphics.drawPix(p1x, p1y, Graphics.NORMAL_ATTR);//Draw a pixel on the starting position of player 1
	    	Graphics.drawPix(p2x, p2y, Graphics.NORMAL_ATTR);//Draw a pixel on the starting position of player 2

			while ((p1d < 0 || p2d < 0) && !kb.key_ESC) {//While ESC key is not pressed and neither player 1 or player 2 has decided his starting direction
				kb.checkKeys();//Check which keys are pressed

				if (kb.key_Up && p1d != 1) {//If UP is pressed
					p1d = 0;//Set the player 1 direction to up
				}
				else if (kb.key_Down && p1d != 0) {//If DOWN is pressed
					p1d = 1;//Set the player 1 direction to down
				}
				else if (kb.key_Left && p1d != 3) {//If LEFT is pressed
					p1d = 2;//Set the player 1 direction to left
				}
				else if (kb.key_Right && p1d != 2) {//If RIGHT is pressed
					p1d = 3;//Set the player 1 direction to right
				}

				if (kb.key_W && p2d != 1) {//If UP is pressed
					p2d = 0;//Set the player 1 direction to up
				}
				else if (kb.key_S && p2d != 0) {//If DOWN is pressed
					p2d = 1;//Set the player 1 direction to down
				}
				else if (kb.key_A && p2d != 3) {//If LEFT is pressed
					p2d = 2;//Set the player 1 direction to left
				}
				else if (kb.key_D && p2d != 2) {//If RIGHT is pressed
					p2d = 3;//Set the player 1 direction to right
				}
			}

			/*Game loop*/
	    	while (!kb.key_ESC) {//While ESC is not pressed
				kb.checkKeys();//Check which keys are pressed

				if (kb.key_Up && p1d != 1) {//If UP is pressed
					p1d = 0;//Set the player 1 direction to up
				}
				else if (kb.key_Down && p1d != 0) {//If DOWN is pressed
					p1d = 1;//Set the player 1 direction to down
				}
				else if (kb.key_Left && p1d != 3) {//If LEFT is pressed
					p1d = 2;//Set the player 1 direction to left
				}
				else if (kb.key_Right && p1d != 2) {//If RIGHT is pressed
					p1d = 3;//Set the player 1 direction to right
				}

				if (kb.key_W && p2d != 1) {//If UP is pressed
					p2d = 0;//Set the player 1 direction to up
				}
				else if (kb.key_S && p2d != 0) {//If DOWN is pressed
					p2d = 1;//Set the player 1 direction to down
				}
				else if (kb.key_A && p2d != 3) {//If LEFT is pressed
					p2d = 2;//Set the player 1 direction to left
				}
				else if (kb.key_D && p2d != 2) {//If RIGHT is pressed
					p2d = 3;//Set the player 1 direction to right
				}

				switch (p1d) {
					case 0: {//if the player 1 direction is up
						p1y = p1y - 1;//decrement the y coordinate of player 1
						break;
					}
					case 1: {//if the player 1 direction is down
						p1y = p1y + 1;//increment the y coordinate of player 1
						break;
					}
					case 2: {//if the player 1 direction is left
						p1x = p1x - 1;//decrement the x coordinate of player 1
						break;
					}
					case 3: {//if the player 1 direction is right
						p1x = p1x + 1;//increment the x coordinate of player 1
						break;
					}
				}

				switch (p2d) {
					case 0: {//if the player 2 direction is up
						p2y = p2y - 1;//decrement the y coordinate of player 2
						break;
					}
					case 1: {//if the player 2 direction is down
						p2y = p2y + 1;//increment the y coordinate of player 2
						break;
					}
					case 2: {//if the player 2 direction is left
						p2x = p2x - 1;//decrement the x coordinate of player 2
						break;
					}
					case 3: {//if the player 2 direction is right
						p2x = p2x + 1;//increment the x coordinate of player 2
						break;
					}
				}

				if (Graphics.getPix(p1x, p1y) && Graphics.getPix(p2x, p2y)) {//if the player 1 and the player 2 is about to hit a wall
					Graphics.draw((short)0, (short)0, "Nobody wins the round !", Graphics.REPLACE_ATTR);//Draw the String "Nobody wins the round !"
					Keyboard.flush();//Flush the keyboard queue
					System.read();//Wait for the user to press a key
					break;//break the game loop
				}
				else if (Graphics.getPix(p1x, p1y)) {//if the player 1 is about to hit a wall
					p2p++;//Give a point to player 2 (increment p2p)
					Graphics.draw((short)0, (short)0, "Player 2 wins the round !", Graphics.REPLACE_ATTR);//Draw the String "Player 2 wins the round !"
					Keyboard.flush();//Flush the keyboard queue
					System.read();//Wait for the user to press a key
					break;//break the game loop
				}
				else if (Graphics.getPix(p2x, p2y)) {//if the player 2 is about to hit a wall
					p1p++;//Give a point to player 2 (increment p2p)
					Graphics.draw((short)0, (short)0, "Player 1 wins the round !", Graphics.REPLACE_ATTR);//Draw the String "Player 1 wins the round !"
					Keyboard.flush();//Flush the keyboard queue
					System.read();//Wait for the user to press a key
					break;//break the game loop
				}

				Graphics.drawPix(p2x, p2y, Graphics.NORMAL_ATTR);//Draw a pixel on the new position of the player 2
				Graphics.drawPix(p1x, p1y, Graphics.NORMAL_ATTR);//Draw a pixel on the new position of the player 1

				Timer.wait(1);//Wait for an amount of time (1/20 second)
			}
	    }

		System.clrscr();//Clear the screen
		System.println("TRON");//Write "TRON" then next line
		if (p1p != p2p) {//If there is a winner
			System.print("Player ");//Write "Player "
			System.print((short)(p1p > p2p ? 1 : 2));//Write the winner number
		}
		else {
			System.print("Nobody");//Write "Nobody"
		}
		System.println(" wins the game !");//Write " wins !" then next line
		System.println();//Next line
		System.print("Press a key ...");//Write "Press a key ..."
		Keyboard.flush();//Flush the keyboard queue
		System.read();//Wait for the user to press a key

		kb.finalize();//Finalize kb
    }
}