/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */

/*
 *  This file is part of Moka.
 *
 *  Moka is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Moka; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import moka.x.Frame;
import moka.x.ComboBox;
import moka.x.OptionPane;

/**
 * This class represents a window a ComboBox in it.
 *
 * @author  Frdric Brown
 */
public class Combo extends Frame {
	/** A ComboBox.*/
	private ComboBox list;

	/**
	 * Constructs a new Combo frame.
	 */
	public Combo () {
		super("Select your city");//Call the superclass' constructor, passing the string "Select your city" as argument

		this.setBounds(0s, 0s, 150s, 100s);//Set the bounds of this frame to x=0, y=0, width=150 and height=100
		this.setMinimizeButtonVisible(false);//Hide the minimize button of the title bar
		this.defaultCloseOperation = Frame.EXIT_ON_CLOSE;//Set the default close operation for this frame to EXIT ON CLOSE

		this.list = new ComboBox();//Instantiate a new ComboBox displaying a list of cities
		this.list.setBounds(2s, 15s, 140s, 17s);//Set the bounds of the list to x=2, y=15, width=140 and height=17

		this.list.items.push("Qubec");//Add the String "Qubec" to the list
		this.list.items.push("Mexico");//Add the String "Mexico" to the list
		this.list.items.push("Paris");//Add the String "Paris" to the list
		this.list.items.push("London");//Add the String "London" to the list
		this.list.items.push("Washington");//Add the String "Washington" to the list
		this.list.items.push("Moscow");//Add the String "Moscow" to the list
		this.list.items.push("Bogota");//Add the String "Bogota" to the list
		this.list.items.push("Colombo");//Add the String "Colombo" to the list

		this.list.update();//Update the list

		this.add(this.list);//Add list into this frame
	}

	/**
	 * The main static method, the entry point of the program.
	 */
	public static void main () {
		Combo f = new Combo();//Instantiate a new Combo Frame

		f.setVisible(true);//Show the Combo frame
	}

	/**
	 * Called when a CloseEvent occurs.  Will display a confirmation message.
	 */
	public void onClose() {
		if (this.list.index >= 0) {
			OptionPane.showMessageDialog((Container)null, "Your selection :", (String)this.list.getSelectedItem().toString());//Show a dialog displaying the selected city
		}

		this.list.clear();//Empty the ComboBox finalizing all its items

		super.onClose();//Call the superclass onClose method : dispose of the frame.
	}
}