/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */

/*
 *  This file is part of Moka.
 *
 *  Moka is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Moka; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import moka.x.Frame;
import moka.x.Button;
import moka.x.MenuBar;
import moka.x.Menu;
import moka.x.MenuItem;
import moka.x.OptionPane;

/**
 * This class is a windowed "Hello world!" featuring a menu.
 *
 * @author  Frdric Brown
 */
public class MenuApp extends Frame {
	/** The quit button.*/
	private Button btnQuit;
	
	/** The menu bar.*/
	private MenuBar bar;
	
		/** The 'File' menu.*/
		private Menu mFile;	
		
			/** The 'Quit' menu item*/
			private MenuItem itmQuit;

		/** The 'File' menu.*/
		private Menu mHelp;	
		
			/** The 'Quit' menu item*/
			private MenuItem itmAbout;

	/**
	 * Constructs a new MenuApp frame.
	 */
	public MenuApp () {
		super("Hello world!");//Call the superclass' constructor, passing the string "Hello world!" as argument

		this.setBounds(0s, 0s, 150s, 100s);//Set the bounds of this frame to x=0, y=0, width=150 and height=100
		this.setMinimizeButtonVisible(false);//Hide the minimize button of the title bar
		this.defaultCloseOperation = Frame.EXIT_ON_CLOSE;//Set the default close operation for this frame to EXIT ON CLOSE

		this.btnQuit = new Button("Quit");//Instantiate a new Button labeled "Quit"
		this.btnQuit.setBounds(0s, 0s, 40s, 17s);//Set the bounds of the quit button to x=0, y=0, width=40 and height=17
		this.btnQuit.setMnemonic('Q');//Set the mnemonic for the quit button to 'Q'
		this.btnQuit.listen = this;//Set this frame as EventListener for the quit button
		this.add(this.btnQuit);//Add the quit button into this frame
		this.btnQuit.center();//Center the button
		
		this.bar = new MenuBar();//Instanciate a new MenuBar
		this.addMenuBar(this.bar);//Assign the menubar to this frame
			this.mFile = new Menu("File");//Instanciate a new Menu labeled "File"
			this.mFile.mnemonic = 'F';//Set the mnemonic for the file menu to 'F'
			this.bar.add(this.mFile);//Add the file menu to the menubar
				this.itmQuit = new MenuItem("Quit");//Instanciate a new MenuItem
				this.itmQuit.mnemonic = 'Q';//Set the mnemonic for the quit item to 'Q'
				this.itmQuit.listen = this;//Assign this frame as its event listener
				this.mFile.add(this.itmQuit);//Add the quit item to the file menu
			this.mHelp = new Menu("Help");//Instanciate a new Menu labeled "Help"
			this.mHelp.mnemonic = 'H';//Set the mnemonic for the help menu to 'H'
			this.bar.add(this.mHelp);//Add the file menu to the menubar
				this.itmAbout = new MenuItem("About...");//Instanciate a new MenuItem
				this.itmAbout.mnemonic = 'A';//Set the mnemonic for the quit item to 'A'
				this.itmAbout.listen = this;//Assign this frame as its event listener
				this.mHelp.add(this.itmAbout);//Add the about item to the file menu
	}

	/**
	 * Called when an Event occurs.
	 */
	public void eventTriggered (Object sender) {
		if ((sender == this.btnQuit) || (sender == this.itmQuit)) {//If the sender is the quit button or the Quit menu item
			this.dispose();//Dispose of this window
		}
		else if (sender == this.itmAbout) {//If the sender is the about item
			OptionPane.showMessageDialog("An example program !");
		}
	}

	public static void main () {
		MenuApp f = new MenuApp();//Instantiate a new MenuApp Frame
		f.setVisible(true);//Show the MenuApp frame
	}
}