/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */

/*
 *  This file is part of Moka.
 *
 *  Moka is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Moka; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import moka.x.Frame;
import moka.x.CheckBox;

/**
 * This class represents a Window with CheckBoxes.
 *
 * @author  Frdric Brown
 */
public class Check extends Frame {
	/** A RadioButton.*/
	private CheckBox cb1;
	/** A RadioButton.*/
	private CheckBox cb2;

	/**
	 * Constructs a new Hello frame.
	 */
	public Check () {
		super("Grocery list");//Call the superclass' constructor, passing the string "Grocery list" as argument

		this.setBounds(5s, 15s, 150s, 100s);//Set the bounds of this frame to x=5, y=15, width=150 and height=100
		this.setMinimizeButtonVisible(false);//Hide the minimize button of the title bar
		//this.defaultCloseOperation = Frame.EXIT_ON_CLOSE;//Set the default close operation for this frame to EXIT ON CLOSE

		this.cb1 = new CheckBox("Milk");//Instantiate a new CheckBox labeled "Milk"
		this.cb1.setBounds(2s, 15s, 60s, 17s);//Set the bounds of the cb1 button to x=2, y=15, width=60 and height=17
		this.cb1.setMnemonic('I');//Set the mnemonic for the rb1 button to 'I'
		this.add(this.cb1);//Add cb1 into this frame

		this.cb2 = new CheckBox("Bread");//Instantiate a new CheckBox labeled "Bread"
		this.cb2.setBounds(2s, 35s, 60s, 17s);//Set the bounds of the rb2 button to x=2, y=35, width=60 and height=17
		this.cb2.setMnemonic('B');//Set the mnemonic for the rb2 button to 'B'
		this.add(this.cb2);//Add cb2 into this frame
	}

	/**
	 * Called when a CloseEvent occurs.  Will display a confirmation message.
	 */
	public void onClose() {
		if (OptionPane.showConfirmDialog((Container)null, "Will close the frame", "Are you sure ?", OptionPane.YES_NO_OPTION) == OptionPane.YES_OPTION) {//If the user click on the yes button of the confirm dialog.
			super.onClose();//Call the superclass onClose method : dispose of the frame.
		}
	}
}