/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */

/*
 *  This file is part of Moka.
 *
 *  Moka is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Moka; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import moka.x.Frame;
import moka.x.RadioButton;
import moka.x.RadioGroup;
import moka.x.OptionPane;

/**
 * This class is the main class of an exemple of RadioButton and Checkbox use.
 * This class represents a Window displaying 3 radio buttons.
 *
 * @author  Frdric Brown
 */
public class Radio extends Frame {
	/** A RadioButton.*/
	private RadioButton rb1;
	/** A RadioButton.*/
	private RadioButton rb2;
	/** A RadioButton.*/
	private RadioButton rb3;
	/** The RadioGroup.*/
	private RadioGroup rGroup;

	/**
	 * Constructs a new Hello frame.
	 */
	public Radio () {
		super("Your answer ?");//Call the superclass' constructor, passing the string "Your answer ?" as argument

		this.setBounds(0s, 0s, 150s, 100s);//Set the bounds of this frame to x=0, y=0, width=150 and height=100
		this.setMinimizeButtonVisible(false);//Hide the minimize button of the title bar
		this.defaultCloseOperation = Frame.EXIT_ON_CLOSE;//Set the default close operation for this frame to EXIT ON CLOSE

		this.rGroup = new RadioGroup();//Instantiate a new RadioGroup

		this.rb1 = new RadioButton("Yes");//Instantiate a new RadioButton labeled "Yes"
		this.rb1.setBounds(2s, 15s, 60s, 17s);//Set the bounds of the rb1 button to x=2, y=15, width=60 and height=17
		this.rb1.setMnemonic('Y');//Set the mnemonic for the rb1 button to 'Y'
		this.rb1.setGroup(this.rGroup);//Sets the RadioGroup of rb1 to this.rGroup
		this.add(this.rb1);//Add rb1 into this frame

		this.rb2 = new RadioButton("No");//Instantiate a new RadioButton labeled "No"
		this.rb2.setBounds(2s, 35s, 60s, 17s);//Set the bounds of the rb2 button to x=2, y=35, width=60 and height=17
		this.rb2.setMnemonic('N');//Set the mnemonic for the rb2 button to 'N'
		this.rb2.setGroup(this.rGroup);//Sets the RadioGroup of rb2 to this.rGroup
		this.add(this.rb2);//Add rb2 into this frame

		this.rb3 = new RadioButton("Maybe");//Instantiate a new RadioButton labeled "Maybe"
		this.rb3.setBounds(2s, 55s, 60s, 17s);//Set the bounds of the rb3 button to x=2, y=55, width=60 and height=17
		this.rb3.setMnemonic('M');//Set the mnemonic for the rb3 button to 'M'
		this.rb3.setGroup(this.rGroup);//Sets the RadioGroup of rb2 to this.rGroup
		this.add(this.rb3);//Add rb3 into this frame
	}

	/**
	 * Called when a CloseEvent occurs.  Will display a confirmation message.
	 */
	public void onClose() {
		if (OptionPane.showConfirmDialog((Container)null, "Will close the program", "Are you sure ?", OptionPane.YES_NO_OPTION) == OptionPane.YES_OPTION) {//If the user click on the yes button of the confirm dialog.
			super.onClose();//Call the superclass onClose method : dispose of the frame.
		}
	}
	
    /**
     * Frees the ressources used by this object.
     */
	public void finalize () {
		this.rGroup.finalize();
		super.finalize();
	}

	/**
	 * The main static method, the entry point of the program.
	 */
	public static void main () {
		Radio r = new Radio();//Instantiate a new Radio Frame
		Check c = new Check();//Instantiate a new Check Frame

		r.setVisible(true);//Show the Radio frame
		c.setVisible(true);//Show the Check frame
	}
}