/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */

/*
 *  This file is part of Moka.
 *
 *  Moka is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Moka; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import moka.x.Frame;
import moka.x.TextArea;

/**
 * This class represents a window with a TextArea in it.
 *
 * @author  Frdric Brown
 */
public class TxtFrame extends Frame {
	/** A TextArea.*/
	private TextArea txt;

	/**
	 * Constructs a new TxtFrame frame.
	 */
	public TxtFrame () {
		super("Diary");//Call the superclass' constructor, passing the string "Diary" as argument

		this.setBounds(0s, 0s, 150s, 100s);//Set the bounds of this frame to x=0, y=0, width=150 and height=100
		this.setMinimizeButtonVisible(false);//Hide the minimize button of the title bar
		this.defaultCloseOperation = Frame.EXIT_ON_CLOSE;//Set the default close operation for this frame to EXIT ON CLOSE

		this.txt = new TextArea();//Instantiate a new TextArea
		this.txt.setBounds(2s, 15s, 140s, 80s);//Set the bounds of the TextArea to x=2, y=15, width=140 and height=80
		this.txt.setCaption("Each person must form his own conception of the past. No one is satisfied with the accomplishments of the others who have gone before them, even if they were experts. History always has two components: that which took place and the person who views it from a perspective in time and seeks to understands it.  -Golo Mann");//Set the content of the TextArea
		this.txt.setFont(Font.FONT_4x6);//Set the font to 4x6
		this.add(this.txt);//Add txt into this frame
	}

	/**
	 * The main static method, the entry point of the program.
	 */
	public static void main () {
		TxtFrame f = new TxtFrame();//Instantiate a new List Frame

		f.setVisible(true);//Show the List frame
	}
}